"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[69475],{802737:(e,n,t)=>{t.r(n),t.d(n,{assets:()=>c,contentTitle:()=>a,default:()=>d,frontMatter:()=>s,metadata:()=>o,toc:()=>l});var i=t(474848),r=t(28453);const s={title:"Integrate with VMware vCenter",sidebar_label:"VMware vCenter"},a="VMware vCenter",o={id:"services/vmware-vcenter/index",title:"Integrate with VMware vCenter",description:"Support level: Community",source:"@site/integrations/services/vmware-vcenter/index.md",sourceDirName:"services/vmware-vcenter",slug:"/services/vmware-vcenter/",permalink:"/integrations/services/vmware-vcenter/",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/integrations/services/vmware-vcenter/index.md",tags:[],version:"current",frontMatter:{title:"Integrate with VMware vCenter",sidebar_label:"VMware vCenter"},sidebar:"integrations",previous:{title:"Xen Orchestra",permalink:"/integrations/services/xen-orchestra/"},next:{title:"Apache Guacamole\u2122",permalink:"/integrations/services/apache-guacamole/"}},c={},l=[{value:"What is vCenter",id:"what-is-vcenter",level:2},{value:"Preparation",id:"preparation",level:2},{value:"Step 1",id:"step-1",level:3},{value:"Step 2",id:"step-2",level:3},{value:"Step 3",id:"step-3",level:3},{value:"Step 4",id:"step-4",level:3},{value:"vCenter Setup",id:"vcenter-setup",level:2}];function h(e){const n={a:"a",admonition:"admonition",blockquote:"blockquote",code:"code",em:"em",h1:"h1",h2:"h2",h3:"h3",header:"header",img:"img",li:"li",p:"p",pre:"pre",ul:"ul",...(0,r.R)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)(n.header,{children:(0,i.jsx)(n.h1,{id:"vmware-vcenter",children:"VMware vCenter"})}),"\n",(0,i.jsx)("span",{class:"badge badge--secondary",children:"Support level: Community"}),"\n",(0,i.jsx)(n.h2,{id:"what-is-vcenter",children:"What is vCenter"}),"\n",(0,i.jsxs)(n.blockquote,{children:["\n",(0,i.jsx)(n.p,{children:"vCenter Server is the centralized management utility for VMware, and is used to manage virtual machines, multiple ESXi hosts, and all dependent components from a single centralized location. VMware vMotion and svMotion require the use of vCenter and ESXi hosts."}),"\n",(0,i.jsxs)(n.p,{children:["-- ",(0,i.jsx)(n.a,{href:"https://en.wikipedia.org/wiki/VCenter",children:"https://en.wikipedia.org/wiki/VCenter"})]}),"\n"]}),"\n",(0,i.jsx)(n.admonition,{type:"caution",children:(0,i.jsx)(n.p,{children:"This requires authentik 0.10.3 or newer."})}),"\n",(0,i.jsx)(n.admonition,{type:"caution",children:(0,i.jsx)(n.p,{children:"This requires VMware vCenter 7.0.0 or newer."})}),"\n",(0,i.jsx)(n.admonition,{type:"note",children:(0,i.jsx)(n.p,{children:"It seems that the vCenter still needs to be joined to the Active Directory Domain, otherwise group membership does not work correctly. We're working on a fix for this, for the meantime your vCenter should be part of your Domain."})}),"\n",(0,i.jsx)(n.h2,{id:"preparation",children:"Preparation"}),"\n",(0,i.jsx)(n.p,{children:"The following placeholders will be used:"}),"\n",(0,i.jsxs)(n.ul,{children:["\n",(0,i.jsxs)(n.li,{children:[(0,i.jsx)(n.code,{children:"vcenter.company"})," is the FQDN of the vCenter server."]}),"\n",(0,i.jsxs)(n.li,{children:[(0,i.jsx)(n.code,{children:"authentik.company"})," is the FQDN of the authentik install."]}),"\n"]}),"\n",(0,i.jsx)(n.p,{children:"Since vCenter only allows OpenID-Connect in combination with Active Directory/LDAP, it is recommended to have authentik sync with the same Active Directory. You also have the option of connecting to an authentik managed LDAP outpost for user management."}),"\n",(0,i.jsx)(n.h3,{id:"step-1",children:"Step 1"}),"\n",(0,i.jsxs)(n.p,{children:["Under ",(0,i.jsx)(n.em,{children:"Customization"})," -> ",(0,i.jsx)(n.em,{children:"Property Mappings"}),", create a ",(0,i.jsx)(n.em,{children:"Scope Mapping"}),'. Give it a name like "OIDC-Scope-VMware-vCenter". Set the scope name to ',(0,i.jsx)(n.code,{children:"openid"})," and the expression to the following"]}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-python",children:'return {\n  "domain": "<your active directory domain>",\n}\n'})}),"\n",(0,i.jsxs)(n.p,{children:["If you are using an authentik managed LDAP outpost you can use the following expression in your property mapping. This will correctly return the ",(0,i.jsx)(n.code,{children:"groups"})," claim as a list of LDAP DNs instead of their names."]}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-python",children:'ldap_base_dn = "DC=ldap,DC=goauthentik,DC=io"\ngroups = []\nfor group in request.user.ak_groups.all():\n    group_dn = f"CN={group.name},dc=groups,{ldap_base_dn}"\n    groups.append(group_dn)\nreturn {\n    "name": request.user.name,\n    "email": request.user.email,\n    "given_name": request.user.name,\n    "preferred_username": request.user.username,\n    "nickname": request.user.username,\n    "groups": groups,\n    "domain": "ldap.goauthentik.io"\n}\n'})}),"\n",(0,i.jsx)(n.h3,{id:"step-2",children:"Step 2"}),"\n",(0,i.jsx)(n.admonition,{type:"note",children:(0,i.jsx)(n.p,{children:"If your Active Directory Schema is the same as your Email address schema, skip to Step 3."})}),"\n",(0,i.jsxs)(n.p,{children:["Under ",(0,i.jsx)(n.em,{children:"Sources"}),", click ",(0,i.jsx)(n.em,{children:"Edit"}),' and ensure that "authentik default Active Directory Mapping: userPrincipalName" has been added to your source.']}),"\n",(0,i.jsx)(n.h3,{id:"step-3",children:"Step 3"}),"\n",(0,i.jsxs)(n.p,{children:["Under ",(0,i.jsx)(n.em,{children:"Providers"}),", create an OAuth2/OpenID provider with these settings:"]}),"\n",(0,i.jsxs)(n.ul,{children:["\n",(0,i.jsxs)(n.li,{children:["Redirect URI: ",(0,i.jsx)(n.code,{children:"https://vcenter.company/ui/login/oauth2/authcode"})]}),"\n",(0,i.jsx)(n.li,{children:'Sub Mode: If your Email address Schema matches your UPN, select "Based on the User\'s Email...", otherwise select "Based on the User\'s UPN...". If you are using authentik\'s managed LDAP outpost, chose "Based on the User\'s username"'}),"\n",(0,i.jsx)(n.li,{children:"Scopes: Select the Scope Mapping you've created in Step 1"}),"\n",(0,i.jsx)(n.li,{children:"Signing Key: Select any available key"}),"\n"]}),"\n",(0,i.jsx)(n.p,{children:(0,i.jsx)(n.img,{src:t(464805).A+"",width:"1348",height:"1067"})}),"\n",(0,i.jsx)(n.h3,{id:"step-4",children:"Step 4"}),"\n",(0,i.jsx)(n.p,{children:"Create an application which uses this provider. Optionally apply access restrictions to the application."}),"\n",(0,i.jsxs)(n.p,{children:["Set the Launch URL to ",(0,i.jsx)(n.code,{children:"https://vcenter.company/ui/login/oauth2"}),". This will skip vCenter's User Prompt and directly log you in."]}),"\n",(0,i.jsx)(n.admonition,{type:"caution",children:(0,i.jsxs)(n.p,{children:["This Launch URL only works for vCenter < 7.0u2. If you're running 7.0u2 or later, set the launch URL to ",(0,i.jsx)(n.code,{children:"https://vcenter.company/ui/login"})]})}),"\n",(0,i.jsx)(n.h2,{id:"vcenter-setup",children:"vCenter Setup"}),"\n",(0,i.jsxs)(n.p,{children:["Login as local Administrator account (most likely ends with vsphere.local). Using the Menu in the Navigation bar, navigate to ",(0,i.jsx)(n.em,{children:"Administration -> Single Sing-on -> Configuration"}),"."]}),"\n",(0,i.jsxs)(n.p,{children:["Click on ",(0,i.jsx)(n.em,{children:"Change Identity Provider"})," in the top-right corner."]}),"\n",(0,i.jsx)(n.p,{children:'In the wizard, select "Microsoft ADFS" and click Next.'}),"\n",(0,i.jsxs)(n.p,{children:["Fill in the Client Identifier and Shared Secret from the Provider in authentik. For the OpenID Address, click on ",(0,i.jsx)(n.em,{children:"View Setup URLs"})," in authentik, and copy the OpenID Configuration URL."]}),"\n",(0,i.jsx)(n.p,{children:"On the next page, fill in your Active Directory Connection Details. These should be similar to what you have set in authentik."}),"\n",(0,i.jsx)(n.p,{children:(0,i.jsx)(n.img,{src:t(348596).A+"",width:"1317",height:"597"})}),"\n",(0,i.jsx)(n.p,{children:"If your vCenter was already setup with LDAP beforehand, your Role assignments will continue to work."})]})}function d(e={}){const{wrapper:n}={...(0,r.R)(),...e.components};return n?(0,i.jsx)(n,{...e,children:(0,i.jsx)(h,{...e})}):h(e)}},464805:(e,n,t)=>{t.d(n,{A:()=>i});const i=t.p+"assets/images/authentik_setup-c5c28c7dcaf44c71432e20e0be329429.png"},348596:(e,n,t)=>{t.d(n,{A:()=>i});const i=t.p+"assets/images/vcenter_post_setup-f883b20e050b8525769df992de404a3d.png"}}]);