"use strict";(self.webpackChunk_goauthentik_website_docs=self.webpackChunk_goauthentik_website_docs||[]).push([[35693],{511073:(e,n,t)=>{t.r(n),t.d(n,{assets:()=>a,contentTitle:()=>l,default:()=>h,frontMatter:()=>o,metadata:()=>r,toc:()=>d});var i=t(474848),s=t(28453);const o={title:"Full development environment"},l=void 0,r={id:"developer-docs/setup/full-dev-environment",title:"Full development environment",description:"Requirements",source:"@site/docs/developer-docs/setup/full-dev-environment.md",sourceDirName:"developer-docs/setup",slug:"/developer-docs/setup/full-dev-environment",permalink:"/docs/developer-docs/setup/full-dev-environment",draft:!1,unlisted:!1,editUrl:"https://github.com/goauthentik/authentik/edit/main/website/docs/developer-docs/setup/full-dev-environment.md",tags:[],version:"current",frontMatter:{title:"Full development environment"},sidebar:"docs",previous:{title:"Contributing to authentik",permalink:"/docs/developer-docs/"},next:{title:"Frontend-only development environment",permalink:"/docs/developer-docs/setup/frontend-dev-environment"}},a={},d=[{value:"Requirements",id:"requirements",level:2},{value:"Services Setup",id:"services-setup",level:2},{value:"Backend Setup",id:"backend-setup",level:2},{value:"Frontend Setup",id:"frontend-setup",level:2},{value:"Running authentik",id:"running-authentik",level:2}];function c(e){const n={a:"a",admonition:"admonition",code:"code",h2:"h2",li:"li",ol:"ol",p:"p",pre:"pre",strong:"strong",ul:"ul",...(0,s.R)(),...e.components};return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)(n.h2,{id:"requirements",children:"Requirements"}),"\n",(0,i.jsxs)(n.ul,{children:["\n",(0,i.jsx)(n.li,{children:"Python 3.12"}),"\n",(0,i.jsx)(n.li,{children:"Poetry, which is used to manage dependencies"}),"\n",(0,i.jsx)(n.li,{children:"Go 1.23 or newer"}),"\n",(0,i.jsx)(n.li,{children:"Node.js 21 or newer"}),"\n",(0,i.jsx)(n.li,{children:"PostgreSQL 14 or newer"}),"\n",(0,i.jsx)(n.li,{children:"Redis (any recent version will do)"}),"\n"]}),"\n",(0,i.jsx)(n.h2,{id:"services-setup",children:"Services Setup"}),"\n",(0,i.jsxs)(n.p,{children:["For PostgreSQL and Redis, you can use the ",(0,i.jsx)(n.code,{children:"docker-compose.yml"})," file in ",(0,i.jsx)(n.code,{children:"/scripts"}),".To use these pre-configured database instances, navigate to the ",(0,i.jsx)(n.code,{children:"/scripts"})," directory in your local copy of the authentik git repo, and run ",(0,i.jsx)(n.code,{children:"docker compose up -d"}),".\nYou can also use a native install, if you prefer."]}),"\n",(0,i.jsx)(n.admonition,{type:"info",children:(0,i.jsxs)(n.p,{children:["If you use locally installed databases, the PostgreSQL credentials given to authentik should have permissions for ",(0,i.jsx)(n.code,{children:"CREATE DATABASE"})," and ",(0,i.jsx)(n.code,{children:"DROP DATABASE"}),", because authentik creates a temporary database for tests."]})}),"\n",(0,i.jsx)(n.h2,{id:"backend-setup",children:"Backend Setup"}),"\n",(0,i.jsx)(n.admonition,{type:"info",children:(0,i.jsxs)(n.p,{children:["Depending on your platform, some native dependencies might be required. On macOS, run ",(0,i.jsx)(n.code,{children:"brew install libxmlsec1 libpq krb5"}),", and for the CLI tools ",(0,i.jsx)(n.code,{children:"brew install postgresql redis node@20"}),"."]})}),"\n",(0,i.jsxs)(n.ol,{children:["\n",(0,i.jsx)(n.li,{children:"Create an isolated Python environment. To create the environment and install dependencies, run the following commands in the same directory as your local authentik git repository:"}),"\n"]}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-shell",children:"poetry shell # Creates a python virtualenv, and activates it in a new shell\nmake install # Installs all required dependencies for Python and Javascript, including development dependencies\n"})}),"\n",(0,i.jsxs)(n.ol,{start:"2",children:["\n",(0,i.jsx)(n.li,{children:"Configure authentik to use the local databases using a local config file. To generate this file, run the following command in the same directory as your local authentik git repository:"}),"\n"]}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-shell",children:"make gen-dev-config # Generates a local config file\n"})}),"\n",(0,i.jsx)(n.p,{children:"Generally speaking, authentik is a Django application, ran by gunicorn, proxied by a Go application. The Go application serves static files."}),"\n",(0,i.jsx)(n.p,{children:"Most functions and classes have type-hints and docstrings, so it is recommended to install a Python Type-checking Extension in your IDE to navigate around the code."}),"\n",(0,i.jsx)(n.p,{children:"Before committing code, run the following commands in the same directory as your local authentik git repository:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-shell",children:"make lint # Ensures your code is well-formatted\nmake gen # Generates an updated OpenAPI Docs for any changes you make\n"})}),"\n",(0,i.jsx)(n.h2,{id:"frontend-setup",children:"Frontend Setup"}),"\n",(0,i.jsx)(n.p,{children:"By default, no compiled bundle of the frontend is included so this step is required even if you're not developing for the UI."}),"\n",(0,i.jsx)(n.p,{children:"To build the UI once, run the following command in the same directory as your local authentik git repository:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-shell",children:"make web-build # Builds the UI once\n"})}),"\n",(0,i.jsx)(n.p,{children:"If you want to live-edit the UI, you can run the following command in the same directory as your local authentik git repository instead, which will immediately update the UI with any changes you make so you can see the results in real time without needing to rebuild:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-shell",children:"make web-watch # Updates the UI with any changes you make\n"})}),"\n",(0,i.jsx)(n.p,{children:"To format the frontend code, run the following command in the same directory as your authentik git repository:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-shell",children:"make web # Formats the frontend code\n"})}),"\n",(0,i.jsx)(n.h2,{id:"running-authentik",children:"Running authentik"}),"\n",(0,i.jsx)(n.p,{children:"Now that the backend and frontend have been setup and built, you can start authentik by running the following command in the same directory as your local authentik git repository:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-shell",children:"ak server # Starts authentik server\n"})}),"\n",(0,i.jsxs)(n.p,{children:["And now, authentik should now be accessible at ",(0,i.jsx)(n.code,{children:"http://localhost:9000"}),"."]}),"\n",(0,i.jsxs)(n.admonition,{type:"info",children:[(0,i.jsxs)(n.p,{children:["To define a password for the default admin (called ",(0,i.jsx)(n.strong,{children:"akadmin"}),"), you can manually enter the ",(0,i.jsx)(n.code,{children:"/if/flow/initial-setup/"})," path in the browser address bar to launch the initial flow. Example: ",(0,i.jsx)(n.a,{href:"http://localhost:9000/if/flow/initial-setup/",children:"http://localhost:9000/if/flow/initial-setup/"}),"."]}),(0,i.jsxs)(n.p,{children:["In case of issues in this process, feel free to use ",(0,i.jsx)(n.code,{children:"make dev-reset"}),' which drops and restores the Authentik PostgreSQL instance to a "fresh install" state.']})]})]})}function h(e={}){const{wrapper:n}={...(0,s.R)(),...e.components};return n?(0,i.jsx)(n,{...e,children:(0,i.jsx)(c,{...e})}):c(e)}}}]);